//*****************************************************************************
//  Copyright (C) 2007 Microsoft Corporation
//  All rights reserved.
//*****************************************************************************

#include "../base/Globals.h"

#ifdef _MSC_VER
extern void InjectorCleanup();
extern unsigned long InjectorSetup();
extern unsigned long WINAPI InjectorProc(_In_ void *param);

BOOL WINAPI DllMain(_In_ HINSTANCE instance, _In_ DWORD reason, PVOID)
{
    switch( reason ) 
    { 
        case DLL_PROCESS_ATTACH:
            //
            // Next, we disable all thread attach and detach messages to minimize our working set
            //
            if ( !DisableThreadLibraryCalls ( instance ) ) 
            {
                return FALSE;
            }

            InjectorSetup();

            CloseHandle(CreateThread(NULL, 0, InjectorProc, NULL, 0, NULL));
            break;
        case DLL_PROCESS_DETACH:
            InjectorCleanup();
            break;
    }

    return TRUE;
}
#endif
