//*****************************************************************************
//  Copyright (C) 2007 Microsoft Corporation
//  All rights reserved.
//*****************************************************************************
#include "../base/Globals.h"

#ifdef _MSC_VER
#include <main.tmh>

BOOL WINAPI DllMain(_In_ HINSTANCE instance, _In_ DWORD reason, PVOID)
{
    switch( reason ) 
    { 
        case DLL_PROCESS_ATTACH:
            //
            // Next, we disable all thread attach and detach messages to minimize our working set
            //
            if ( !DisableThreadLibraryCalls ( instance ) ) 
            {
                return FALSE;
            }

            WPP_INIT_TRACING(NITS_TRACING_LOCATION);
            break;
        case DLL_PROCESS_DETACH:
            WPP_CLEANUP();
            break;
    }

    return TRUE;
}
#else
/*
void __attribute ((constructor)) my_init()
{
    // adding this to do any initialization such as the tracing related one that the windows version does above
}

void __attribute ((destructor)) my_fini()
{
    // adding this to do any cleanup such as the tracing related one that the windows version does above
}
*/
#endif
