#define TEST_BUILD

#ifdef _MSC_VER
# include <windows.h>
#endif

#include <nits.h>

using namespace TestSystem;

struct MyStruct
{
    int x;
    wchar_t *p;
};

struct MyStruct1
{
    int a, b;
};

struct MyStruct2
{
    int c, d;
};

NitsSetup0(Fixture0, MyStruct)
    NitsContext()->_MyStruct->x = 0;
    NitsContext()->_MyStruct->p = 0;
NitsEndSetup
    
NitsCleanup(Fixture0)
    NitsContext()->_MyStruct->x = 0;
NitsEndCleanup



NitsCrash(Fixture0)
    NitsContext()->_MyStruct->x = 0;
NitsEndCrash

NitsSetup(SimpleSetup)
NitsEndSetup

NitsTest(SimpleBody)
    TTRACE(L"SimpleBody being run");
    TASSERT(true, L"test passed");          
NitsEndTest

NitsTestWithSetup(BodyWithSimpleSetup, SimpleSetup)
    TTRACE(L"BodyWithSimpleSetup being run");
    TASSERT(true, L"test passed");          
NitsEndTest


struct MyStruct sBodyWithInitializableSetup = {9, 0};

NitsTestWithInitializableSetup(BodyWithInitializableSetup, Fixture0, sBodyWithInitializableSetup)
    TTRACE(L"BodyWithInitializableSetup being run");
    TASSERT(true, L"test passed");          
NitsEndTest

NitsSetup0(Fixture1, MyStruct)
    NitsContext()->_MyStruct->x = 0;
    NitsContext()->_MyStruct->p = 0;
NitsEndSetup




struct MyStruct sFixture2 = {9, 0};

NitsSetup1(Fixture2, MyStruct2, Fixture0, sFixture2)
    NitsContext()->_MyStruct2->c = 0;
    NitsContext()->_MyStruct2->d = 0;

    // doing initialization directly; this way we will potentially have this following code pasted in several tests
    NitsContext()->_Fixture0->_MyStruct->x = 0;
    NitsContext()->_Fixture0->_MyStruct->p = 0;
NitsEndSetup



struct MyStruct sFixture4 = {12, 0};

NitsSetup1(Fixture4, MyStruct2, Fixture0, sFixture4)
    NitsContext()->_MyStruct2->c = 0;
    NitsContext()->_MyStruct2->d = 0;

    NitsContext()->_Fixture0->_MyStruct->x = 0;
    NitsContext()->_Fixture0->_MyStruct->p = 0;
NitsEndSetup


struct MyStruct2 sFixture5 = {5, 10};

NitsSetup2(Fixture5, MyStruct2, Fixture2, sFixture5, Fixture4, sFixture5)
    NitsContext()->_MyStruct2->c = 0;
    NitsContext()->_MyStruct2->d = 0;

    NitsContext()->_Fixture2->_Fixture0->_MyStruct->x = 0;
    NitsContext()->_Fixture2->_Fixture0->_MyStruct->p = 0;

    NitsContext()->_Fixture4->_Fixture0->_MyStruct->x = 0;
    NitsContext()->_Fixture4->_Fixture0->_MyStruct->p = 0;
NitsEndSetup


struct MyStruct sFixture3 = {3, 0};


NitsSplit2(Fixture3, MyStruct,
           Fixture0,
           Fixture1)
    // convenient way of accessing currently selected choice
    NitsContext()->_MyStruct->x = 0;
    NitsContext()->_MyStruct->p = 0;

    // you could do it this way too
    NitsContext()->_Fixture0->_MyStruct->x = 0;
    NitsContext()->_Fixture0->_MyStruct->p = 0;

    NitsContext()->_Fixture1->_MyStruct->x = 0;
    NitsContext()->_Fixture1->_MyStruct->p = 0;
NitsEndSetup


struct FirstTest
{
    int x;
};

NitsTest0(FirstTestWithNewInterface)
    TTRACE(L"FirstTestWithNewInterface being run");
    TASSERT(true, L"test passed");
NitsEndTest


NitsTest(BodyOnlyTest)
    TTRACE(L"BodyOnlyTest being run");
    TASSERT(true, L"test passed");
NitsEndTest

NitsSetup(MySetup1)
    TTRACE(L"MySetup1 being run");
NitsEndSetup

NitsCleanup(MySetup1)
    TTRACE(L"Cleanup for MySetup1 being run");
NitsEndCleanup

NitsSetup(MySetup2)
    TTRACE(L"MySetup2 being run");
NitsEndSetup

NitsCleanup(MySetup2)
    TTRACE(L"Cleanup for MySetup2 being run");
NitsEndCleanup


NitsSplit2(SetupWithTwoParentsSplit, NitsEmptyStruct, 
           MySetup1, MySetup2)
    TTRACE(L"SetupWithTwoParentsSplit being run");
NitsEndSetup

NitsCleanup(SetupWithTwoParentsSplit)
    TTRACE(L"Cleanup for SetupWithTwoParentsSplit being run");
NitsEndCleanup


NitsTest1(BodyWithSplitParent, SetupWithTwoParentsSplit, NitsEmptyValue)
    TTRACE(L"BodyWithSplitParent being run");
    TASSERT(true, L"test passed");
NitsEndTest


NitsTestWithSetup(BodyWithSetup, MySetup1)
    TTRACE(L"BodyWithSetup being run");
    TASSERT(true, L"test passed");
NitsEndTest

NitsTest2(BodyWithTwoParents, MySetup1, NitsEmptyValue, MySetup2, NitsEmptyValue)
    TTRACE(L"BodyWithSetup being run");
    TASSERT(true, L"test passed");
NitsEndTest


// this is not supported i.e. test having a split; you have to inherit from a split
/*
NitsTest3(BodyWithTwoParentsSplit, MySetup1, NitsEmptyValue, MySetup2, NitsEmptyValue, SplitFixture, NitsEmptyValue)
    TTRACE(L"BodyWithSetup being run");
    TASSERT(true, L"test passed");
NitsEndTest
*/

NitsCleanup(BodyWithSplitParent)
    TTRACE(L"Cleanup for BodyWithSplitParent being run");
NitsEndCleanup

NitsSetup(P1_1)
    TTRACE(L"P1_1 being run");
NitsEndSetup

NitsSetup(P1_2)
    TTRACE(L"P1_2 being run");
NitsEndSetup

NitsSetup2(P1, NitsEmptyStruct, 
           P1_1, NitsEmptyValue,
           P1_2, NitsEmptyValue)
   TTRACE(L"P1 being run");
NitsEndSetup

NitsSetup(P2_1)
    TTRACE(L"P2_1 being run");
NitsEndSetup

NitsSetup1(P2, NitsEmptyStruct,
           P2_1, NitsEmptyValue)
   TTRACE(L"P2 being run");
NitsEndSetup

NitsTest2(T1,
          P1, NitsEmptyValue,
          P2, NitsEmptyValue)
   TTRACE(L"T1 being run");
   TASSERT(true, L"test passed");
NitsEndSetup

NitsSplit2(Split_P1_P2, NitsEmptyStruct, 
          P1, P2)

    TTRACE(L"Split_P1_P2 being run");
NitsEndSplit

NitsTest1(T2,
          Split_P1_P2, NitsEmptyValue)
   TTRACE(L"T2 being run");
   TASSERT(true, L"test passed");
NitsEndSetup

NitsSetup(C1_1)
    TTRACE(L"C1_1 being run");
NitsEndSetup

NitsCleanup(C1_1)
     TTRACE(L"Cleanup of C1_1 being run");
NitsEndCleanup

NitsSetup(C1_2)
    TTRACE(L"C1_2 being run");
NitsEndSetup


NitsSplit2(C1, NitsEmptyStruct, 
           C1_1,
           C1_2)           
   TTRACE(L"C1 being run");
NitsEndSetup

NitsCleanup(C1)
     TTRACE(L"Cleanup of C1 being run");
NitsEndCleanup

NitsSetup(D1_1)
    if(NitsIsFixtureSelected(C1_1))
        NitsOmitAndReturn;
    TTRACE(L"D1_1 being run");
NitsEndSetup

NitsCleanup(D1_1)
     TTRACE(L"Cleanup of D1_1 being run");
NitsEndCleanup

NitsSetup(D1_2)
    TTRACE(L"D1_2 being run");
NitsEndSetup


NitsSplit2(D1, NitsEmptyStruct, 
           D1_1,
           D1_2)
   TTRACE(L"D1 being run");
NitsEndSetup

NitsCleanup(D1)
     TTRACE(L"Cleanup of D1 being run");
NitsEndCleanup

NitsTest2(TC1D1,
          C1, NitsEmptyValue,
          D1, NitsEmptyValue)
 TTRACE(L"TC1D1 being run");
 TASSERT(true, L"test passed");
NitsEndSetup

NitsCleanup(TC1D1)
     TTRACE(L"Cleanup of TC1D1 being run");
NitsEndCleanup

NitsSetup1(MySetup1C1, NitsEmptyStruct,
           MySetup1, NitsEmptyValue)
    TTRACE(L"MySetup1C1 being run");
NitsEndSetup

NitsSetup1(MySetup1C2, NitsEmptyStruct,
           MySetup1, NitsEmptyValue)
    TTRACE(L"MySetup1C2 being run");
NitsEndSetup

NitsTest2(VITest1, 
          MySetup1C1, NitsEmptyValue,
          MySetup1C2, NitsEmptyValue)
    TTRACE(L"VITest1 being run");
    TASSERT(true, L"test passed");          
NitsEndTest

// DEMO Test

struct MyContext
{
    char *bom;
    int length;
};

char *currentBom = 0;


void SetBom(_In_reads_(length) char *bom, int length)
{
    currentBom = bom;
}

int DecodeData(_In_reads_(length) char *someData, int length)
{
    // do the decoding 
    // when successful return 1
    return 1;
}

void PrintBom(_In_reads_(length) char *bom, int length)
{
    int count = 0;

    if(!bom || (length == 0))
        return;
    
    while((count < length) && bom[count] != 0)
    {
        // code to print each char
        count++;
    }

    if(count == 3)
    {
        TTRACE(L"BOM is 123");
    }
    else if(count == 2)
    {
        TTRACE(L"BOM is 45");
    }
}

NitsSetup0(UTF8, MyContext)
    char temp[] = {1, 2, 3, 0};
    NitsContext()->_MyContext->bom = temp;
    NitsContext()->_MyContext->length = 4;
    TTRACE(L"Running UTF8");
NitsEndSetup
    
NitsSetup0(UTF16, MyContext)
    char temp[] = {4, 5, 0};
    NitsContext()->_MyContext->bom = temp;
    NitsContext()->_MyContext->length = 3;    
    TTRACE(L"Running UTF16");    
NitsEndSetup
    
NitsSplit2(Encodings, MyContext, UTF8, UTF16)
    TTRACE(L"Running Encodings");
    PrintBom(NitsContext()->_MyContext->bom, NitsContext()->_MyContext->length);
NitsEndSplit
    
NitsTest1(DecoderTest,
        Encodings, EncodingsDefaults)
    int x = 0;
    char someData[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
    TTRACE(L"Running DecoderTest");
    PrintBom(NitsContext()->_Encodings->_MyContext->bom, NitsContext()->_Encodings->_MyContext->length);
    SetBom(NitsContext()->_Encodings->_MyContext->bom, NitsContext()->_Encodings->_MyContext->length);
    x = DecodeData(someData, 10);
    NitsAssert(x, L"Foo failed");
NitsEndTest

void FaultSimHelper1()
{
    char *mem1 = (char *)malloc(10);
    char *mem2 = (char *)malloc(15);

    // faulting on mem1 alloc
    if(ShouldFault(TLINE))
    {
        TASSERT(false, L"mem1 alloc failed");
    }

    if(mem1)
        free(mem1);

    // faulting on mem2 alloc
    if(ShouldFault(TLINE))
    {
        TASSERT(false, L"mem2 alloc failed");
    }

    if(mem2)
        free(mem2);
}
void FaultSimHelper()
{
    char *mem1 = (char *)malloc(10);
    char *mem2 = (char *)malloc(15);
    char *mem3 = (char *)malloc(20);
    char *mem4 = (char *)malloc(25);

    // faulting on mem1 alloc
    if(ShouldFault(TLINE))
    {
        TASSERT(false, L"mem1 alloc failed");
    }

    if(mem1)
        free(mem1);

    // faulting on mem2 alloc
    if(ShouldFault(TLINE))
    {
        TASSERT(false, L"mem2 alloc failed");
    }

    if(mem2)
        free(mem2);

    // faulting on mem3 alloc
    if(ShouldFault(TLINE))
    {
        TASSERT(false, L"mem3 alloc failed");
    }

    if(mem3)
        free(mem3);

    // faulting on mem4 alloc
    if(ShouldFault(TLINE))
    {
        TASSERT(false, L"mem4 alloc failed");
    }

    if(mem4)
        free(mem4);

    FaultSimHelper1();
}

NitsTest2(VITest1FaultSim, 
          MySetup1C1, NitsEmptyValue,
          MySetup1C2, NitsEmptyValue)
    NitsEnableFaultSim;

    FaultSimHelper();

    FaultSimHelper1();

    TTRACE(L"VITest1 being run");
    TASSERT(true, L"test passed");          
NitsEndTest


NitsTest2(TC1D1FaultSim,
          C1, NitsEmptyValue,
          D1, NitsEmptyValue)
    NitsEnableFaultSim;

    FaultSimHelper();

    FaultSimHelper1();

    TTRACE(L"TC1D1 being run");
    TASSERT(true, L"test passed");
NitsEndSetup

NitsTest(FaultSimTest1)
    NitsEnableFaultSim;

    FaultSimHelper();

    FaultSimHelper1();

    TTRACE(L"FaultSimTest1 being run");    
    
    TASSERT(true, L"test passed");
NitsEndTest

struct FooStruct1
{
    int i1;
};

struct FooStruct2
{
    int i2;
};

NitsSetup0(FooSetup1, FooStruct1)
    TASSERT(NitsContext()->_FooStruct1->i1 == 10, L"wrong value");
    NitsContext()->_FooStruct1->i1 = 15;
    TTRACE(L"FooSetup1 being run");            
NitsEndSetup

struct FooStruct1 sFooStruct1 = {10};

NitsSetup1(FooSetup2, FooStruct2, FooSetup1, sFooStruct1)
    TASSERT(NitsContext()->_FooSetup1->_FooStruct1->i1 == 15, L"wrong value");
    NitsContext()->_FooSetup1->_FooStruct1->i1 = 35;
    TASSERT(NitsContext()->_FooStruct2->i2 == 20, L"wrong value");
    NitsContext()->_FooStruct2->i2 = 25;
    TTRACE(L"FooSetup2 being run");        
NitsEndSetup

struct FooStruct2 sFooStruct2 = {20};

NitsTest1(FooTest, FooSetup2, sFooStruct2)
    TASSERT(NitsContext()->_FooSetup2->_FooStruct2->i2 == 25, L"wrong value");    
    TASSERT(NitsContext()->_FooSetup2->_FooSetup1->_FooStruct1->i1 == 35, L"wrong value");    
    NitsContext()->_FooSetup2->_FooStruct2->i2 = 45;
    NitsContext()->_FooSetup2->_FooSetup1->_FooStruct1->i1 = 55;
    TTRACE(L"FooTest being run");            
NitsEndTest

NitsCleanup(FooTest)
    TASSERT(NitsContext()->_FooSetup2->_FooStruct2->i2 == 45, L"wrong value");
    TASSERT(NitsContext()->_FooSetup2->_FooSetup1->_FooStruct1->i1 == 55, L"wrong value");    
    TTRACE(L"FooTest cleanup being run");                
NitsEndCleanup

