#ifndef _pal_keylock_h
#define _pal_keylock_h

#include "palcommon.h"
#include "atomic.h"

#define KEYLOCKS_SIZE 64

PAL_BEGIN_EXTERNC

extern ptrdiff_t __keyLocks[KEYLOCKS_SIZE];

PAL_INLINE ptrdiff_t __KeyLock_Hash(
    _In_ ptrdiff_t x)
{
    return x ^ (x >> 3) ^ (x >> 12) ^ (x >> 22);
}

PAL_INLINE void KeyLock_Acquire(
    _In_ ptrdiff_t key)
{
    ptrdiff_t hash = __KeyLock_Hash(key);
    Atomic_Lock(&__keyLocks[hash % KEYLOCKS_SIZE]);
}

PAL_INLINE void KeyLock_Release(
    _In_ ptrdiff_t key)
{
    ptrdiff_t hash = __KeyLock_Hash(key);
    Atomic_Unlock(&__keyLocks[hash % KEYLOCKS_SIZE]);
}

PAL_END_EXTERNC

#endif /* _pal_keylock_h */
