#include "once.h"
#include "mutex.h"

/* ATTN: use locks when available */

static Mutex s_lock = MUTEX_INITIALIZER;

void __Once_Invoke(
    _Inout_ Once* self,
    _In_ void (*func)(void* data),
    _In_ void* data)
{
    Mutex_Acquire(&s_lock);

    if (self->invoked == 0)
    {
        if (func)
            (*func)(data);

        self->invoked = 1;
    }

    Mutex_Release(&s_lock);
}
