#ifndef _pal_once_h
#define _pal_once_h

#include <stddef.h>
#include "palcommon.h"

#define ONCE_INITIALIZER { 0 }

PAL_BEGIN_EXTERNC

typedef struct _Once 
{
    unsigned char invoked;
}
Once;

void __Once_Invoke(
    _Inout_ Once* self,
    _In_ void (*func)(void* data),
    _In_ void* data);

PAL_INLINE void Once_Invoke(
    _Inout_ Once* self,
    _In_ void (*func)(void* data),
    _In_ void* data)
{
    if (self->invoked == 0)
        __Once_Invoke(self, func, data);
}

PAL_END_EXTERNC

#endif /* _pal_once_h */
