#ifndef _pal_palcommon_h
#define _pal_palcommon_h

#include <stddef.h>
#include <stdlib.h>
#include <limits.h>

#if defined(_MSC_VER)
# include <windows.h>
#endif

/*
**==============================================================================
**
** PAL_UNUSED
**
**==============================================================================
*/

#define PAL_UNUSED(X) ((void)X)

/*
**==============================================================================
**
** PAL_USE_WCHAR
**
**==============================================================================
*/

#if defined(_MSC_VER)
# define PAL_USE_WCHAR
#endif

/*
**==============================================================================
**
** PAL_HAVE_POSIX
**
**==============================================================================
*/

#if defined(linux)
# define PAL_HAVE_POSIX
#endif

/*
**==============================================================================
**
** PAL_HAVE_PTHREADS
**
**==============================================================================
*/

#if defined(linux)
# define PAL_HAVE_PTHREADS
#endif

/*
**==============================================================================
**
** PAL_BEGIN_EXTERNC
** PAL_END_EXTERNC
**
**==============================================================================
*/

#if defined(__cplusplus)
# define PAL_BEGIN_EXTERNC extern "C" {
# define PAL_END_EXTERNC }
#else
# define PAL_BEGIN_EXTERNC
# define PAL_END_EXTERNC
#endif

/*
**==============================================================================
**
** PAL_INLINE macro
**
**==============================================================================
*/

#if defined(_MSC_VER)
# define PAL_INLINE static __inline
#elif defined(__GNUC__)
# define PAL_INLINE static __inline
#elif defined(sun)
# define PAL_INLINE static inline
#elif defined(aix)
# define PAL_INLINE static inline
#else
# define PAL_INLINE static __inline
#endif

/*
**==============================================================================
**
** PAL_EXPORT macro
**
**==============================================================================
*/

#if defined(_MSC_VER)
# define PAL_EXPORT __declspec(dllexport)
# define PAL_IMPORT __declspec(dllimport)
#elif defined(__GNUC__)
# define PAL_EXPORT __attribute__((visibility("default")))
# define PAL_IMPORT /* empty */
#elif defined(sun)
# define PAL_EXPORT __global 
# define PAL_IMPORT /* empty */
#else
# error "unsupported"
#endif

/*
**==============================================================================
**
** PAL string
**
**==============================================================================
*/

#if defined(_MSC_VER)
typedef wchar_t PAL_Char;
#else
typedef char PAL_Char;
#endif

/*
**==============================================================================
**
** PAL_T()
**
**==============================================================================
*/

#if defined(_MSC_VER)
# define PAL_T(STR) L##STR
#else
# define PAL_T(STR) STR
#endif


/*
**==============================================================================
**
** Basic types
**
**==============================================================================
*/

typedef unsigned char PAL_Boolean;

typedef unsigned char PAL_Uint8;
typedef signed char PAL_Sint8;

typedef unsigned short PAL_Uint16;
typedef signed short PAL_Sint16;

typedef unsigned int PAL_Uint32;
typedef signed int PAL_Sint32;

#if defined(_MSC_VER)
typedef unsigned __int64 PAL_Uint64;
typedef signed __int64 PAL_Sint64;
#else
typedef unsigned long long PAL_Uint64;
typedef signed long long PAL_Sint64;
#endif

/*
**==============================================================================
**
** SAL Notation for non-Windows
**
**==============================================================================
*/

#if !defined(_MSC_VER)

# ifndef _In_
#  define _In_
# endif

# ifndef _Out_
#  define _Out_
# endif
 
# ifndef _Inout_
#  define _Inout_
# endif
 
#endif /* !defined(_MSC_VER) */

/*
**==============================================================================
**
** PAL_MAX_PATH_SIZE
**
**==============================================================================
*/

#define PAL_MAX_PATH_SIZE 1024

#endif /* _pal_palcommon_h */
