#ifndef _pal_shmem_h
#define _pal_shmem_h


#include <stddef.h>
#include "palcommon.h"

PAL_BEGIN_EXTERNC

typedef struct _Shmem 
{
#if defined(_MSC_VER)
    HANDLE handle;
#else
    int shmid;
#endif
} 
Shmem;

typedef enum _ShmemAccess
{
    SHMEM_ACCESS_READONLY = 1,
    SHMEM_ACCESS_READWRITE = 2,
}
ShmemAccess;

int Shmem_Open(
    _Out_ Shmem* self,
    _In_ const PAL_Char* name,
    _In_ ShmemAccess access,
    _In_ size_t size);

int Shmem_Close(
    _Inout_ Shmem* self);

void* Shmem_Map(
    _Inout_ Shmem* self,
    _In_ ShmemAccess access,
    _In_ ptrdiff_t offset,
    _In_ size_t size);


int Shmem_Unmap(
    _Inout_ Shmem* self,
    _In_ void* ptr,
    _In_ size_t size);

size_t Shmem_Granularity();

PAL_END_EXTERNC

#endif /* _pal_shmem_h */
