#ifndef _pal_sleep_h
#define _pal_sleep_h

#include <stddef.h>
#include "palcommon.h"

#if defined(PAL_HAVE_POSIX)
# include <unistd.h>
# include <time.h>
#endif

PAL_BEGIN_EXTERNC

PAL_INLINE void Sleep_Milliseconds(
    _In_ unsigned long milliseconds)
{
#if defined(_MSC_VER)
    Sleep((DWORD)milliseconds);
#else
    struct timespec ts;
    ts.tv_sec = (long)(milliseconds / 1000);
    ts.tv_nsec = (long)((milliseconds % 1000) * 1000 * 1000);
    nanosleep(&ts, NULL);
#endif
}

PAL_END_EXTERNC

#endif /* _pal_sleep_h */
