/*
**==============================================================================
**
** Open Management Infrastructure (OMI)
**
** Copyright (c) Microsoft Corporation
** 
** Licensed under the Apache License, Version 2.0 (the "License"); you may not 
** use this file except in compliance with the License. You may obtain a copy 
** of the License at 
**
**     http://www.apache.org/licenses/LICENSE-2.0 
**
** THIS CODE IS PROVIDED *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
** KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED 
** WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, 
** MERCHANTABLITY OR NON-INFRINGEMENT. 
**
** See the Apache 2 License for the specific language governing permissions 
** and limitations under the License.
**
**==============================================================================
*/

#define WQL_OR 257
#define WQL_AND 258
#define WQL_NOT 259
#define WQL_ERROR 260
#define WQL_LT 261
#define WQL_FROM 262
#define WQL_LE 263
#define WQL_WHERE 264
#define WQL_NE 265
#define WQL_GT 266
#define WQL_REAL 267
#define WQL_EQ 268
#define WQL_SELECT 269
#define WQL_GE 270
#define WQL_NULL 271
#define WQL_IDENTIFIER 272
#define WQL_BOOLEAN 273
#define WQL_INTEGER 274
#define WQL_STRING 275
#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
typedef union
{
    WQL_Symbol symbol;
    ZChar* string;
    long long integer;
    double real;
    unsigned char boolean;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
extern YYSTYPE wqllval;
